Index: code/branches/Asteroid_HS17/data/levels/Asteroids2D.oxw
===================================================================
--- code/branches/Asteroid_HS17/data/levels/Asteroids2D.oxw	(revision 11593)
+++ code/branches/Asteroid_HS17/data/levels/Asteroids2D.oxw	(revision 11608)
@@ -6,6 +6,4 @@
 />
 
-
-<!--wird immer gebraucht-->
 <?lua
   include("stats.oxo")
@@ -13,14 +11,14 @@
 ?>
 
-
 <?lua
-  include ("overlays/HUDTemplates3.oxo")
+  include("templates/spaceshipAssff2.oxt")
+  include("templates/spaceshipPirate.oxt")
   include("templates/spaceshipAsteroids2D.oxt")
+  include("templates/enemyInvader.oxt")
+  include("overlays/Asteroids2DHUD.oxo")
 ?>
 
-<!--Templates schreiben oder von spaceship kopieren-->
-
 <Level
-  plugin = asteroids2D
+  plugins = asteroids2D
   gametype = Asteroids2D
 >
@@ -30,24 +28,25 @@
   <?lua include("includes/notifications.oxi") ?>
 
-    <!-- ambientlight = "0.8, 0.8, 0.8"
-    skybox       = "Orxonox/Starbox" 
-    WorldRange lieber im src einschraenken-->
   <Scene
-    ambientlight = "0.8, 0.7, 0.4"
-    skybox     = "Orxonox/skyBoxBasic"
+    ambientlight = "1.0, 1.0, 1.0"
+    skybox       = "Orxonox/Starbox"
+    negativeWorldRange = "-100000, -100000, -100000"
+    positiveWorldRange = " 100000,  100000,  100000"
   >
+
+  <WorldAmbientSound
+    source="Earth.ogg"
+    looping="true"
+    playOnLoad="true"
+  />
+
+    <!-- <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0"/> -->
+    <Light type=directional position="-100, 10000, -700" lookat="0.2, -1, 0" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
+    <SpawnPoint team=0 position="0,0,0" lookat="0,0,0" spawnclass= Asteroids2DShip pawndesign=spaceshipasteroids2d />
+
+    <Model mesh="axes.mesh" scale=10 position="0,0,0" />
+    <Asteroids2DCenterPoint name=asteroids2Dcenter />
   
-    <!-- <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0"/> -->
-    <Light type=directional position="1100, 11000, -7000" lookat="0, 0, 0" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
-
-    <SpawnPoint team=0 position="0,0,0" lookat="0,0,0" spawnclass=Asteroids2DShip pawndesign=spaceshipasteroids2D/>
-  
-    <Asteroids2DCenterPoint name=asteroids2Dcenter />
-
-    <Model mesh="axes.mesh" scale=10 position="0,0,-100" />
-    
     
   </Scene>
 </Level>
-
-
Index: code/branches/Asteroid_HS17/data/levels/MiniGameTest.oxw
===================================================================
--- code/branches/Asteroid_HS17/data/levels/MiniGameTest.oxw	(revision 11593)
+++ code/branches/Asteroid_HS17/data/levels/MiniGameTest.oxw	(revision 11608)
@@ -15,6 +15,5 @@
   include("templates/spaceshipMiniGameTest.oxt")
   include("templates/enemyInvader.oxt")
-  include("templates/DodgeRacePattern.oxt")
-  include("overlays/DodgeRaceHUD.oxo")
+  include("overlays/MiniGameTestHUD.oxo")
 ?>
 
@@ -30,5 +29,5 @@
   <Scene
     ambientlight = "1.0, 1.0, 1.0"
-    skybox       = "Orxonox/skyBoxClouds"
+    skybox       = "Orxonox/Starbox"
     negativeWorldRange = "-100000, -100000, -100000"
     positiveWorldRange = " 100000,  100000,  100000"
@@ -43,5 +42,7 @@
     <!-- <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0"/> -->
     <Light type=directional position="-100, 10000, -700" lookat="0.2, -1, 0" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
-    <SpawnPoint team=0 position="-200,0,0" lookat="0,0,0" spawnclass= MiniGameTestShip pawndesign=spaceshipdodgerace />
+    <SpawnPoint team=0 position="0,0,0" lookat="0,0,0" spawnclass= MiniGameTestShip pawndesign=spaceshipminigametest />
+
+    <Model mesh="axes.mesh" scale=10 position="0,0,0" />
 
     <DistanceTrigger name="start" position="-200,0,0" target="Pawn" distance=10 stayActive="true" delay=0 />
@@ -50,14 +51,5 @@
     <MiniGameTestCenterPoint name=invadercenter />
   
-  <StaticEntity position="0,-50,0" direction="0,0,0"   scale="1" collisionType=static mass=1 friction=0.01 >
-      <attached>
-        <Model position="0,0,0" mesh="plane.mesh" scale3D="100000,0,100000" />
-      </attached>
 
-      <collisionShapes>
-        <BoxCollisionShape position="0,0,0" halfExtents="1,1,1" />
-      </collisionShapes>
-
-  </StaticEntity>
     
   
Index: code/branches/Asteroid_HS17/data/levels/templates/spaceshipAsteroids2D.oxt
===================================================================
--- code/branches/Asteroid_HS17/data/levels/templates/spaceshipAsteroids2D.oxt	(revision 11593)
+++ code/branches/Asteroid_HS17/data/levels/templates/spaceshipAsteroids2D.oxt	(revision 11608)
@@ -1,18 +1,18 @@
-<Template name=spaceshipasteroids2D>
-  <SpaceShip
+<Template name=spaceshipasteroids2d>
+  <Asteroids2DShip
    hudtemplate            = spaceshiphud
    camerapositiontemplate = spaceshipescortcameras
    spawnparticlesource    = "Orxonox/fairytwirl"
    spawnparticleduration  = 3
-   explosionchunks        = 10
+   explosionchunks        = 4
 
-   health            = 80
-   maxhealth         = 200
-   initialhealth     = 80
+   health            = 40
+   maxhealth         = 40
+   initialhealth     = 40
 
-   shieldhealth        = 35
-   initialshieldhealth = 35
-   maxshieldhealth     = 60
-   shieldabsorption    = 0.9
+   shieldhealth        = 20
+   initialshieldhealth = 20
+   maxshieldhealth     = 20
+   shieldabsorption    = 0.1
    shieldrechargerate  = 1
    shieldrechargewaittime = 1
@@ -34,11 +34,15 @@
 
    collisionType     = "dynamic"
-   mass              = 80
-   linearDamping     = 0.7
+   mass              = 4200000
+   linearDamping     = 0.9999999
    angularDamping    = 0.9999999
+
+   collisiondamage = 100
+   enablecollisiondamage = true
+   
   >
     <engines>
-      <MultiStateEngine position=" 7.6, 0, 6" template=spaceshipescortengine />
-      <MultiStateEngine position="-7.6, 0, 0" template=spaceshipescortengine />
+      <MultiStateEngine position=" 7.6, 0, 6" template=spaceshipinvaderengine />
+      <MultiStateEngine position="-7.6, 0, 0" template=spaceshipinvaderengine />
     </engines>
     <attached>
@@ -56,34 +60,38 @@
       <BoxCollisionShape position="0,     0,-12" halfExtents="4  , 4 ,7" />
     </collisionShapes>
-    <explosion>
+    <explosion >
       <ExplosionPart minspeed=0 maxspeed=0 effect1="orxonox/explosion_flash2" effect2="orxonox/explosion_flame2" />
       <ExplosionPart minspeed=0 maxspeed=0 effect1="orxonox/explosion_shockwave2" effect2="orxonox/explosion_sparks2" />
       <ExplosionPart minspeed=0 maxspeed=0 effect1="orxonox/explosion_streak2" effect2="orxonox/explosion_afterglow" />
 
-      <ExplosionPart mesh="explosionparts/escort_part_1.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
-      <ExplosionPart mesh="explosionparts/escort_part_2.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
-      <ExplosionPart mesh="explosionparts/escort_part_3.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
-      <ExplosionPart mesh="explosionparts/escort_part_4.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
-      <ExplosionPart mesh="explosionparts/escort_part_5.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
-      <ExplosionPart mesh="explosionparts/escort_part_6.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
+      <ExplosionPart minspeed=0 maxspeed=0 effect1="Orxonox/explosion2b" effect2="Orxonox/smoke6" />
+      <ExplosionPart mesh="CockpitDebris.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
+      <ExplosionPart mesh="BodyDebris1.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
+      <ExplosionPart mesh="WingDebris1.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
+      <ExplosionPart mesh="WingDebris2.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
     </explosion>
 <?lua
-  include("../includes/weaponSettingsEscort.oxi")
+  include("../includes/invaderWeapon.oxi")
 ?>
-  </SpaceShip>
+  </Asteroids2DShip>
 </Template>
 
 <Template name=spaceshipescortcameras defaults=0>
-  <SpaceShip>
+  <Asteroids2DShip>
     <camerapositions>
-      <CameraPosition position="0,600,0" pitch=-90 absolute=true />
-      <CameraPosition position="0,50,160" drag=true mouselook=false />
-      <CameraPosition position="0,40,125" drag=true mouselook=false/>
-      <CameraPosition position="0,30, 90" drag=true mouselook=false/>
+    <!--<CameraPosition position="0,100,180" direction="0, -0.2, -1" drag=false mouselook=true />
+    <CameraPosition position="0,200,250" direction="0, -0.4, -1" drag=false mouselook=true />
+    <CameraPosition position="0,30,150" direction="0, 0, -1" drag=false mouselook=true />
+    <CameraPosition position="0,1300,-100" direction="0, -1, 0" drag=false mouselook=true />
+-->
+    <CameraPosition position="0,600,0" pitch=-90 absolute=true />
+    <CameraPosition position="0,50,160" drag=true mouselook=true />
+    <CameraPosition position="0,40,125" drag=true mouselook=true />
+    <CameraPosition position="0,30, 90" drag=true mouselook=true />
     </camerapositions>
-  </SpaceShip>
+  </Asteroids2DShip>
 </Template>
 
-<Template name=spaceshipescortengine baseclass=MultiStateEngine>
+<Template name=spaceshipinvaderengine baseclass=MultiStateEngine>
   <MultiStateEngine
    boostfactor    = 2.2
@@ -105,7 +113,4 @@
     <EffectContainer condition="idle">
       <WorldSound mainstate="activity" source="sounds/Engine_idle.ogg" looping=1 active=false/>
-       />
-      <Backlight mainstate=activity active=false scale=0.33 name=bltest position=" 12, -2, 14" colour="0.2, 0.5, 0.65, 1.0" width=150 length=15 lifetime=2 elements=1 trailmaterial="Trail/backlighttrail" turnontime=2 turnofftime=1 material="Flares/ThrusterFlare1" />
-      <Backlight mainstate=activity active=false scale=0.33 name=bltest position="-12, -2, 14" colour="0.2, 0.5, 0.65, 1.0" width=15 length=15 lifetime=2 elements=1 trailmaterial="Trail/backlighttrail" turnontime=2 turnofftime=1 material="Flares/ThrusterFlare1" />
     </EffectContainer>
     <EffectContainer condition="not idle">
@@ -117,8 +122,7 @@
     </EffectContainer>
     <EffectContainer condition="normal or boost">
-      <Backlight mainstate=activity active=false scale=0.33 name=bltest position=" 12, -2, 14" colour="0.2, 1.0, 0.65, 1.0" width=5 length=1500 lifetime=2 elements=1 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
-      <Backlight mainstate=activity active=false scale=0.33 name=bltest position="-12, -2, 14" colour="0.2, 1.0, 0.65, 1.0" width=15 length=1500 lifetime=2 elements=1 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
+      <Backlight mainstate=activity active=false scale=0.33 name=bltest position=" 12, 0, 10" colour="0.2, 1.0, 0.65, 1.0" width=15 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
+      <Backlight mainstate=activity active=false scale=0.33 name=bltest position="-12, 0, 10" colour="0.2, 1.0, 0.65, 1.0" width=15 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
     </EffectContainer>
-
     <EffectContainer condition="boost">
       <Backlight mainstate=activity active=false scale=0.33 name=bltest position=" 12, 0, 10" colour="0.6, 0.8, 0.75, 0.7" width=25 length=1000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
Index: code/branches/Asteroid_HS17/data/levels/templates/spaceshipMiniGameTest.oxt
===================================================================
--- code/branches/Asteroid_HS17/data/levels/templates/spaceshipMiniGameTest.oxt	(revision 11593)
+++ code/branches/Asteroid_HS17/data/levels/templates/spaceshipMiniGameTest.oxt	(revision 11608)
@@ -1,3 +1,3 @@
-<Template name=spaceshipdodgerace>
+<Template name=spaceshipminigametest>
   <MiniGameTestShip
    hudtemplate            = spaceshiphud
@@ -80,8 +80,13 @@
   <MiniGameTestShip>
     <camerapositions>
-		<CameraPosition position="0,100,180" direction="0, -0.2, -1" drag=false mouselook=true />
-		<CameraPosition position="0,200,250" direction="0, -0.4, -1" drag=false mouselook=true />
-		<CameraPosition position="0,30,150" direction="0, 0, -1" drag=false mouselook=true />
-		<CameraPosition position="0,1300,-100" direction="0, -1, 0" drag=false mouselook=true />
+    <!--<CameraPosition position="0,100,180" direction="0, -0.2, -1" drag=false mouselook=true />
+    <CameraPosition position="0,200,250" direction="0, -0.4, -1" drag=false mouselook=true />
+    <CameraPosition position="0,30,150" direction="0, 0, -1" drag=false mouselook=true />
+    <CameraPosition position="0,1300,-100" direction="0, -1, 0" drag=false mouselook=true />
+-->
+    <CameraPosition position="0,600,0" pitch=-90 absolute=true />
+    <CameraPosition position="0,50,160" drag=true mouselook=true />
+    <CameraPosition position="0,40,125" drag=true mouselook=true />
+    <CameraPosition position="0,30, 90" drag=true mouselook=true />
     </camerapositions>
   </MiniGameTestShip>