Index: code/branches/Dialog_HS17/src/modules/dialog/Answer.cc
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/Answer.cc	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/Answer.cc	(revision 11611)
@@ -1,3 +1,4 @@
 #include "Answer.h"
+#include "core/CoreIncludes.h"
 
 
Index: code/branches/Dialog_HS17/src/modules/dialog/Answer.h
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/Answer.h	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/Answer.h	(revision 11611)
@@ -3,4 +3,5 @@
 
 #include "core/BaseObject.h"
+#include "DialogPrereqs.h"
 #include "core/XMLPort.h"
 #include "core/CoreIncludes.h"
@@ -10,9 +11,9 @@
 {
 	
-	class Answer : public BaseObject
+	class _DialogExport Answer : public BaseObject
 	{
 		public:
 			Answer(Context* context);
-		// 	virtual ~Answer();
+			
 			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
Index: code/branches/Dialog_HS17/src/modules/dialog/AnswerId.cc
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/AnswerId.cc	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/AnswerId.cc	(revision 11611)
@@ -1,3 +1,4 @@
 #include "AnswerId.h"
+#include "core/CoreIncludes.h"
 
 
@@ -10,4 +11,5 @@
 		RegisterObject(AnswerId);
 	}
+
 	void AnswerId::XMLPort(Element& xmlelement, XMLPort::Mode mode)
 	{
@@ -17,9 +19,12 @@
 	}
 
-	void AnswerId::setId(std::string Id){
-		this->Id_ = Id;
+	void AnswerId::setId(std::string id)
+	{
+		this->id_ = id;
 	}
-	std::string AnswerId::getId(){
-		return this->Id_;
+	
+	std::string AnswerId::getId()
+	{
+		return this->id_;
 	}
 }
Index: code/branches/Dialog_HS17/src/modules/dialog/AnswerId.h
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/AnswerId.h	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/AnswerId.h	(revision 11611)
@@ -13,12 +13,12 @@
 		public:
 			AnswerId(Context* context);
-		// 	virtual ~AnswerId();
+			
 			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
-			void setId(std::string Id);
-			std::string getId();
+            void setId(std::string Id);
+            std::string getId();
 
 		private: 
-			std::string Id_;
+			std::string id_;
 	};
 }
Index: code/branches/Dialog_HS17/src/modules/dialog/CMakeLists.txt
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/CMakeLists.txt	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/CMakeLists.txt	(revision 11611)
@@ -11,4 +11,5 @@
   FIND_HEADER_FILES
    TOLUA_FILES
+   DialogManager.h
   LINK_LIBRARIES
     orxonox
Index: code/branches/Dialog_HS17/src/modules/dialog/Dialog.cc
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/Dialog.cc	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/Dialog.cc	(revision 11611)
@@ -5,4 +5,5 @@
 #include "Dialog.h"
 #include "Question.h"
+
 
 namespace orxonox
@@ -57,10 +58,10 @@
 	void Dialog::addQuestion(Question* question) //fuegt Question der Map hinzu
 	{
-		//questions_.emplace(question->getQuestionId(), question->getQuestion());
+		this->questions_.insert(make_pair(question->getQuestionId(), question));
 	}
 
 	void Dialog::addAnswer(Answer* answer) //fuegt Answer der Map hinzu
 	{
-		//answers_.emplace(std::make_pair(answer->getAnswerId(), answer->getAnswer()));
+		this->answers_.insert(make_pair(answer->getAnswerId(), answer));
 	}
 
@@ -72,5 +73,5 @@
 	}
 
-	Answer* Dialog::getAnswer(unsigned int index) const//tolua_export		//returned sting der Antwort zur Id.
+	Answer* Dialog::getAnswer(unsigned int index) const	//returned sting der Antwort zur Id.
 	{
 		return nullptr;
@@ -81,6 +82,6 @@
 	{
 
-		Question question = (questions_.find(this->currentQuestionId_))->second;
-		std::vector<std::string> answers = question.getAnswerIds();
+		Question* question = (this->questions_.find(this->currentQuestionId_))->second;
+		std::vector<std::string> answers = question->getAnswerIds();
 		return answers;
 	} 
@@ -98,14 +99,14 @@
     void Dialog::update(std::string givenAnswer)
     {
-    	Answer answer = (answers_.find(givenAnswer))->second;
-    	this->currentQuestionId_ = answer.getNextQuestion();
+    	Answer* answer = (answers_.find(givenAnswer))->second;
+    	this->currentQuestionId_ = answer->getNextQuestion();
     }
 
-    bool Dialog::ending() //tolua_export	//retruned true wenn die Id der Antwort end ist oder keine Antworten auf die frage eingetragen sind
+    bool Dialog::ending() //retruned true wenn die Id der Antwort end ist oder keine Antworten auf die frage eingetragen sind
     {
     	bool end = false;
     	if (this->currentQuestionId_ == "end"){
     		end = true;
-    	} else if ((questions_.find(this->currentQuestionId_)->second).getAnswerIds().empty()){
+    	} else if ((this->questions_.find(this->currentQuestionId_)->second)->getAnswerIds().empty()){
     		end = true;
     	}	
Index: code/branches/Dialog_HS17/src/modules/dialog/Dialog.h
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/Dialog.h	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/Dialog.h	(revision 11611)
@@ -3,4 +3,5 @@
 
 #include "core/BaseObject.h"
+#include "DialogPrereqs.h"
 #include "Question.h"
 #include "Answer.h"
@@ -9,13 +10,15 @@
 #include "overlays/OrxonoxOverlay.h"
 
+#include <map>
+#include <vector>
 #include <string>
 
 namespace orxonox
 {
-	class Dialog : public BaseObject
+	class _DialogExport Dialog : public BaseObject
 	{
 		public:
 			Dialog(Context* context);
-			// virtual ~Dialog();
+
 			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 			virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode);
@@ -30,13 +33,13 @@
 			void addAnswer(Answer* answer); //fuegt Answer der Map hinzu
 
-			Question* getQuestion(unsigned int index) const; //tolua_export	// returned string der momentanen Frage
-			Answer* getAnswer(unsigned int index) const; //tolua_export	// returned string der momentanen Frage
-			std::vector<std::string> getAnswers(); //tolua_export	// returned vector mit allen momentanen AntwortenIds
+			Question* getQuestion(unsigned int index) const; // returned string der momentanen Frage
+			Answer* getAnswer(unsigned int index) const; // returned string der momentanen Frage
+			std::vector<std::string> getAnswers(); 	// returned vector mit allen momentanen AntwortenIds
 
 	 		bool execute(bool bTriggered, BaseObject* trigger);
 
-			void update(std::string givenAnswer);	//tolua_export
+			void update(std::string givenAnswer);
 
-			bool ending(); //tolua_export	//retruned true wenn die Id der Antwort end ist oder keine Antworten auf die frage eingetragen sind
+			bool ending(); //retruned true wenn die Id der Antwort end ist oder keine Antworten auf die frage eingetragen sind
 
 
@@ -44,6 +47,6 @@
 			std::string name_;
 			std::string currentQuestionId_;
-			std::map<std::string, Question> questions_;
-			std::map<std::string, Answer> answers_;
+			std::map<std::string, Question*> questions_;
+			std::map<std::string, Answer*> answers_;
 	};
 }
Index: code/branches/Dialog_HS17/src/modules/dialog/DialogManager.cc
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/DialogManager.cc	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/DialogManager.cc	(revision 11611)
@@ -38,49 +38,2 @@
 	} 
 }
-/*#include "core/CoreIncludes.h"
-#include "core/LuaState.h"
-#include "core/GUIManager.h"
-#include "core/class/Identifier.h"
-#include "core/singleton/ScopedSingletonIncludes.h"
-#include "network/Host.h"
-#include "network/NetworkFunctionIncludes.h"
-#include "DialogManager.h"
-#include <vector>
-#include <string>
-#include "core/XMLPort.h"
-#include "Dialog.h"
-
-
-
-namespace orxonox {
-
-	ManageScopedSingleton(DialogManager, ScopeID::ROOT, false);
-
-
-	DialogManager::DialogManager()
-	{
-		this->currentTalk_ = NULL;
-	}
-
-	void DialogManager::setDialog(Dialog* dialog)
-	{
-		this->currentTalk_ = dialog;	
-	}
-
-	const Dialog& getCurrentDialog()
-	{
-		return this->currentTalk_;
-	}
-	
-	bool DialogManager::empty()
-	{
-		if(this->currentTalk_ == NULL)
-		{
-			return true;
-		}
-		else 
-		{
-			return false;
-		}
-	} 
-} */
Index: code/branches/Dialog_HS17/src/modules/dialog/DialogManager.h
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/DialogManager.h	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/DialogManager.h	(revision 11611)
@@ -1,57 +1,6 @@
-/*
 #ifndef _DialogManager_H__
 #define _DialogManager_H__
 
-#include "core/CoreIncludes.h"
-#include "core/LuaState.h"
-#include "core/GUIManager.h"
-#include "core/class/Identifier.h"
-#include "core/singleton/ScopedSingletonIncludes.h"
-#include "network/Host.h"
-#include "network/NetworkFunctionIncludes.h"
-#include "util/Singleton.h"
-#include <string>
-#include <vector>
-#include "core/config/Configurable.h"
-#include "core/XMLPort.h"
-#include "core/EventIncludes.h"
-#include "Dialog.h"
-
-
-
-
-
-namespace orxonox //tolua_export
-
-{//tolua_export
-	class _OrxonoxExport DialogManager //tolua_export
-	: public Singleton<DialogManager>
-	{//tolua_export
-		friend class Singleton<DialogManager>;
-	
-		public:
-		
-		DialogManager();
-		
-
-		static DialogManager& getInstance() { return Singleton<DialogManager>::getInstance(); } //tolua_export
-		
-
-		void setDialog(Dialog* dialog); //tolua_export	// the triggered dialog sets it self so the lua can get to it.
-		const Dialog& getCurrentDialog(); 	//tolua_export
-		bool empty(); //tolua_export //returns true if no dialog is set.
-
-private:
-	Dialog* currentTalk_; //Dialog which is currently set.
-	static DialogManager* singletonPtr_s;
-
-	};//tolua_export
-}//tolua_export
-#endif
- */
-
-#ifndef _DialogManager_H__
-#define _DialogManager_H__
-
+#include "DialogPrereqs.h"
 #include "util/Singleton.h"
 #include "core/object/Listable.h"
@@ -60,5 +9,5 @@
 namespace orxonox
 {
-    class DialogManager : public Singleton<DialogManager>, public Listable
+    class _DialogExport DialogManager : public Singleton<DialogManager>, public Listable
     {
         friend class Singleton<DialogManager>;
@@ -67,8 +16,7 @@
             DialogManager();
 
-            int getValue() const
-                { return this->value_; }
+           // int getValue() const { return this->value_; }
 
-        	static DialogManager& getInstance() { return Singleton<DialogManager>::getInstance(); }
+        	static DialogManager& getInstance() { return Singleton<DialogManager>::getInstance(); } //toloa_export
 
        	 	void setDialog(Dialog* dialog);
@@ -76,7 +24,10 @@
        		bool empty();
 
+            //form here on all lua functionality used in lua scrips is declared
+
+
         private:
         	Dialog* currentTalk_;
-            int value_;
+            //int value_;
 
             static DialogManager* singletonPtr_s;
Index: code/branches/Dialog_HS17/src/modules/dialog/DialogPrereqs.h
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/DialogPrereqs.h	(revision 11611)
+++ code/branches/Dialog_HS17/src/modules/dialog/DialogPrereqs.h	(revision 11611)
@@ -0,0 +1,79 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Damian 'Mozork' Frick
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Shared library macros, enums, constants and forward declarations for the questsystem module
+*/
+
+#ifndef _DialogPrereqs_H__
+#define _DialogPrereqs_H__
+
+#include "OrxonoxConfig.h"
+#include "OrxonoxPrereqs.h"
+
+//-----------------------------------------------------------------------
+// Shared library settings
+//-----------------------------------------------------------------------
+
+#if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(Dialogue_STATIC_BUILD)
+#  ifdef Dialogue_SHARED_BUILD
+#    define _DialogExport __declspec(dllexport)
+#  else
+#    if defined( __MINGW32__ )
+#      define _DialogExport
+#    else
+#      define _DialogExport __declspec(dllimport)
+#    endif
+#  endif
+#  define _DialogPrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
+#  define _DialogExport  __attribute__ ((visibility("default")))
+#  define _DialogPrivate __attribute__ ((visibility("hidden")))
+#else
+#  define _DialogExport
+#  define _DialogPrivate
+#endif
+
+//-----------------------------------------------------------------------
+// Forward declarations
+//-----------------------------------------------------------------------
+
+namespace orxonox
+{
+
+    class DialogManager;
+    class Dialog;
+    class Answer;
+    class Question;
+    class AnswerId;
+   
+}
+
+#endif /* _DialogPrereqs_H__ */
Index: code/branches/Dialog_HS17/src/modules/dialog/Question.cc
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/Question.cc	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/Question.cc	(revision 11611)
@@ -1,4 +1,4 @@
 #include "Question.h"
-
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: code/branches/Dialog_HS17/src/modules/dialog/Question.h
===================================================================
--- code/branches/Dialog_HS17/src/modules/dialog/Question.h	(revision 11610)
+++ code/branches/Dialog_HS17/src/modules/dialog/Question.h	(revision 11611)
@@ -3,7 +3,9 @@
 
 #include "core/BaseObject.h"
+#include "DialogPrereqs.h"
 #include "AnswerId.h"
 #include "core/XMLPort.h"
 #include "core/CoreIncludes.h"
+
 
 #include <string>
@@ -11,9 +13,9 @@
 namespace orxonox
 {
-	class Question : public BaseObject
+	class _DialogExport Question : public BaseObject
 	{
 		public:
 			Question(Context* context);
-		// 	virtual ~Question();
+
 			virtual void XMLPort(Element& xmelement, XMLPort::Mode mode);
 