Index: /code/branches/Dialog_HS17/data/gui/scripts/Dialog.lua
===================================================================
--- /code/branches/Dialog_HS17/data/gui/scripts/Dialog.lua	(revision 11611)
+++ /code/branches/Dialog_HS17/data/gui/scripts/Dialog.lua	(revision 11612)
@@ -1,11 +1,8 @@
-
--- Dialog.lua
+-- Dialogue.lua
 
 local P = createMenuSheet("Dialog")
 
 P.wrapper = nil
-P.answerList = {}
-P.scrollbarWidht = 13
-P.selectedAnswer = {}
+P.detailsWindows = {}
 
 P.showing = false
@@ -14,13 +11,13 @@
 P.imageHeight = 50
 P.detailImageSize = 100
-P.textHeight = 30
-P.buttonWidth = 85
+P.textHeight = 50
+P.buttonWidth = 50
 
 function P.onLoad()
     P.wrapper = nil
-
 end
 
 function P.onShow()
+
     orxonox.CommandExecutor:execute("setTimeFactor 0")
     P.createDialog()
@@ -37,42 +34,32 @@
 function P.update()
     P.updateDialog()
-    if P.showing == false then
-        return
-    end
-
-    P.cleanup(false)
 end
 
 function P.createDialog()
 
-    local dialogManager = orxonox.DialogManager:getInstance()
+    local manager = orxonox.DialogManager:getInstance()
     
+    ---[[
     root = winMgr:getWindow("orxonox/Dialogue/Inventory")
-    local dialog = dialogManager:getCurrentDialog()
-    root:setText(dialog:getQuestion)
+    local question = orxonox.DialogueManager:getInstance():getquestion()
+    root:setText(question)
     P.wrapper = winMgr:createWindow("MenuWidgets/ScrollablePane", "orxonox/Dialogue/Inventory/Wrapper")
     P.wrapper:setSize(CEGUI.UVector2(CEGUI.UDim(1,0),CEGUI.UDim(1,0)))
     root:addChildWindow(P.wrapper)
     
-    acceptButton = winMgr:createWindow("MenuWidgets/Button", "/a2Button")   --a2 da graphik aus version mit 2 knoepfen uebernommen
-    acceptButton:setPosition(CEGUI.UVector2(CEGUI.UDim(0.1, 0),CEGUI.UDim(0.4, (P.imageHeight-P.textHeight)/2)))
-    acceptButton:setSize(CEGUI.UVector2(CEGUI.UDim(0.8, 0), CEGUI.UDim(0, P.textHeight)))
-    acceptButton:setText("accept")
-    orxonox.GUIManager:subscribeEventHelper(acceptButton, "Clicked", P.name ..".acceptButton_clicked")
-    P.wrapper:addChildWindow(acceptButton)
-    
-    P.answerList = {}                       -- erstellen der tabelle aus AntwortIds und Antworten im Lua
-    local answers = dialog:getAnswers()
-    for ans in answers do
-        P.answerList[ans] = dialog:getAnswer(ans)
-    end
-    --todo herausfinden wie antworten in tabelle enzeigen
+    --]]
+    detailsButton = winMgr:createWindow("MenuWidgets/Button", "/DetailsButton")
+    detailsButton:setPosition(CEGUI.UVector2(CEGUI.UDim(0.1, 0),CEGUI.UDim(0.5, (P.imageHeight-P.textHeight)/2)))
+    detailsButton:setSize(CEGUI.UVector2(CEGUI.UDim(0.25, 0), CEGUI.UDim(0, P.textHeight)))
+    detailsButton:setText("say")
+    orxonox.GUIManager:subscribeEventHelper(detailsButton, "Clicked", P.name ..".Button_clicked")
+    P.wrapper:addChildWindow(detailsButton)
+    --]]
+
 end
 
-
 function P.updateDialog()
-    local dialog = orxonox.DialogManager:getInstance():getDialog()
-    root:setText(dialog:getQuestion)
-    --todo: tabellen updaten 
+    --local questionn = orxonox.DialogueManager:getInstance():getquestion()
+    --root:setText("test")
 end
 
@@ -98,14 +85,15 @@
 
 
-function P.acceptButton_clicked(e)
-    local ending = orxonox.DialogManager:getInstance():getDialog:ending()
+function P.Button_clicked(e)
+    --local ending = orxonox.DialogManager:getInstance():theEnd()
     
-    if ending then
+    --if ending then
         orxonox.CommandExecutor:execute("OrxonoxOverlay toggleVisibility Dialog")
     
-    --herausfindne wie tabelleneintrag uebergeben wird
-    else
-        P.update()
-    end
+    
+   -- else 
+   --     orxonox.DialogueManager:getInstance():a1clicked()
+   --     P.update()
+   -- end
 end
 
Index: /code/branches/Dialog_HS17/data/gui/scripts/Dialogue.lua
===================================================================
--- /code/branches/Dialog_HS17/data/gui/scripts/Dialogue.lua	(revision 11611)
+++ /code/branches/Dialog_HS17/data/gui/scripts/Dialogue.lua	(revision 11612)
@@ -22,4 +22,5 @@
     P.detailPickups = {}
     P.pickupsList = {}
+    
 end
 
@@ -28,6 +29,6 @@
     P.createInventory()
     P.showing = true
+end
 
-end
 
 function P.onHide()
Index: /code/branches/Dialog_HS17/data/overlays/HUDTemplates3.oxo
===================================================================
--- /code/branches/Dialog_HS17/data/overlays/HUDTemplates3.oxo	(revision 11611)
+++ /code/branches/Dialog_HS17/data/overlays/HUDTemplates3.oxo	(revision 11612)
@@ -220,4 +220,10 @@
     />
 
-  </OverlayGroup>
-</Template>
+    <GUIOverlay
+      name = "Dialog"
+      guiname = "Dialog"
+      visible = "false"
+    />
+
+  </OverlayGroup>
+</Template>
Index: /code/branches/Dialog_HS17/src/modules/dialog/Dialog.cc
===================================================================
--- /code/branches/Dialog_HS17/src/modules/dialog/Dialog.cc	(revision 11611)
+++ /code/branches/Dialog_HS17/src/modules/dialog/Dialog.cc	(revision 11612)
@@ -113,3 +113,8 @@
     	return end;
     }
+
+	std::string Dialog::getQuestionString()
+	{
+		return this->questions_.find(this->currentQuestionId_)->second->getQuestion();
+	}
 }
Index: /code/branches/Dialog_HS17/src/modules/dialog/Dialog.h
===================================================================
--- /code/branches/Dialog_HS17/src/modules/dialog/Dialog.h	(revision 11611)
+++ /code/branches/Dialog_HS17/src/modules/dialog/Dialog.h	(revision 11612)
@@ -33,6 +33,6 @@
 			void addAnswer(Answer* answer); //fuegt Answer der Map hinzu
 
-			Question* getQuestion(unsigned int index) const; // returned string der momentanen Frage
-			Answer* getAnswer(unsigned int index) const; // returned string der momentanen Frage
+			Question* getQuestion(unsigned int index) const; // // benoetigt fuer xmlPort
+			Answer* getAnswer(unsigned int index) const; // benoetigt fuer xmlPort
 			std::vector<std::string> getAnswers(); 	// returned vector mit allen momentanen AntwortenIds
 
@@ -43,4 +43,5 @@
 			bool ending(); //retruned true wenn die Id der Antwort end ist oder keine Antworten auf die frage eingetragen sind
 
+			std::string getQuestionString(); //gibt string der momentanen Frage 
 
 		private: 
Index: /code/branches/Dialog_HS17/src/modules/dialog/DialogManager.cc
===================================================================
--- /code/branches/Dialog_HS17/src/modules/dialog/DialogManager.cc	(revision 11611)
+++ /code/branches/Dialog_HS17/src/modules/dialog/DialogManager.cc	(revision 11612)
@@ -2,38 +2,34 @@
 #include "core/CoreIncludes.h"
 #include "core/singleton/ScopedSingletonIncludes.h"
+#include <string>
 
-namespace orxonox
-{
-    ManageScopedSingleton(DialogManager, ScopeID::ROOT, false);
+namespace orxonox {
+	ManageScopedSingleton(DialogManager, ScopeID::ROOT, false);
+	
 
-    RegisterAbstractClass(DialogManager).inheritsFrom<Listable>();
+	
+	DialogManager::DialogManager()
+	{
+		this->currentTalk_ = nullptr;
+	}
 
-    DialogManager::DialogManager()
-    {
-        RegisterObject(DialogManager);
-
-        this->currentTalk_ = NULL;
-    }
-
-    void DialogManager::setDialog(Dialog* dialog)
+	void DialogManager::setDialog(Dialog* dialog)
 	{
 		this->currentTalk_ = dialog;	
 	}
 
-	const Dialog* DialogManager::getCurrentDialog()
-	{
-		return this->currentTalk_;
-	}
-	
-	bool DialogManager::empty()
-	{
-		if(this->currentTalk_ == NULL)
-		{
-			return true;
-		}
-		else 
-		{
-			return false;
-		}
-	} 
+	//from here onward funcionality for lua axports
+
+    std::string DialogManager::getQuestion()
+    {
+    	return this->currentTalk_->getQuestionString();
+    }
+
+    /*
+    std::vector<std::string> DialogManager::getAnswers()
+    {
+    	// lua hat komisch arrays (eigentlich tables), wie implementiert man answers so das man nacher den key der gegeben antwort a
+    	// hat um ihn fuer update zu benutzen?
+    }
+	*/
 }
Index: /code/branches/Dialog_HS17/src/modules/dialog/DialogManager.h
===================================================================
--- /code/branches/Dialog_HS17/src/modules/dialog/DialogManager.h	(revision 11611)
+++ /code/branches/Dialog_HS17/src/modules/dialog/DialogManager.h	(revision 11612)
@@ -4,34 +4,39 @@
 #include "DialogPrereqs.h"
 #include "util/Singleton.h"
+#include "core/singleton/ScopedSingletonIncludes.h"
 #include "core/object/Listable.h"
 #include "Dialog.h"
 
-namespace orxonox
-{
-    class _DialogExport DialogManager : public Singleton<DialogManager>, public Listable
-    {
+#include <string>
+
+namespace orxonox //tolua_export
+
+{//tolua_export
+    class _OrxonoxExport DialogManager //tolua_export
+    : public Singleton<DialogManager>
+    {//tolua_export
         friend class Singleton<DialogManager>;
+    
+        public:
+        
+        DialogManager(); 
+        
 
-        public:
-            DialogManager();
+        static DialogManager& getInstance() { return Singleton<DialogManager>::getInstance(); } //tolua_export
 
-           // int getValue() const { return this->value_; }
+        void setDialog(Dialog* dialog);
 
-        	static DialogManager& getInstance() { return Singleton<DialogManager>::getInstance(); } //toloa_export
+        //from here on luafunctionality is declared
 
-       	 	void setDialog(Dialog* dialog);
-        	const Dialog* getCurrentDialog();
-       		bool empty();
+        std::string getQuestion(); //tolua_export
+        //std::vector<std::string> getAnswers();
 
-            //form here on all lua functionality used in lua scrips is declared
+private:
+    static DialogManager* singletonPtr_s;
 
+    Dialog* currentTalk_;
 
-        private:
-        	Dialog* currentTalk_;
-            //int value_;
-
-            static DialogManager* singletonPtr_s;
-    };
-}
+    };//tolua_export
+}//tolua_export
 
 #endif /* _DialogManager_H__ */
Index: /code/branches/Dialog_HS17/src/modules/dialog/DialogPrereqs.h
===================================================================
--- /code/branches/Dialog_HS17/src/modules/dialog/DialogPrereqs.h	(revision 11611)
+++ /code/branches/Dialog_HS17/src/modules/dialog/DialogPrereqs.h	(revision 11612)
@@ -43,6 +43,6 @@
 //-----------------------------------------------------------------------
 
-#if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(Dialogue_STATIC_BUILD)
-#  ifdef Dialogue_SHARED_BUILD
+#if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(Dialog_STATIC_BUILD)
+#  ifdef Dialog_SHARED_BUILD
 #    define _DialogExport __declspec(dllexport)
 #  else