Index: code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2D.cc
===================================================================
--- code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2D.cc	(revision 11608)
+++ code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2D.cc	(revision 11613)
@@ -55,10 +55,10 @@
         pattern = 1;
         lastPosition = 0;
-        // spawn enemy every 3.5 seconds
-        //enemySpawnTimer.setTimer(3.5f, true, createExecutor(createFunctor(&Asteroids2D::spawnEnemy, this)));
         this->numberOfBots_ = 0; //sets number of default bots temporarly to 0
         this->center_ = nullptr;
         this->setHUDTemplate("Asteroids2DHUD");
     }
+
+
 
     void Asteroids2D::levelUp()
Index: code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2D.h
===================================================================
--- code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2D.h	(revision 11608)
+++ code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2D.h	(revision 11613)
@@ -89,4 +89,5 @@
             void costLife();
 
+
             bool bEndGame;
             bool bShowLevel;
Index: code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DCenterPoint.cc
===================================================================
--- code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DCenterPoint.cc	(revision 11608)
+++ code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DCenterPoint.cc	(revision 11613)
@@ -48,6 +48,6 @@
 
         this->checkGametype();
-        this->width_ = 200;
-        this->height_ = 120;
+        this->width_ = 1043;
+        this->height_ = 646;
     }
     /**
Index: code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DShip.cc
===================================================================
--- code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DShip.cc	(revision 11608)
+++ code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DShip.cc	(revision 11613)
@@ -46,4 +46,6 @@
         isFireing = false;
         damping = 10;
+        this->width = 1043;
+        this->height = 646;
 
         // not sure if has to be zero?
@@ -51,4 +53,12 @@
         lastTimeLeft = 0;
         lastTime = 0;
+        timer.setTimer(3.5f, true, createExecutor(createFunctor(&Asteroids2DShip::showposition, this)));
+    }
+
+    //Use this function to display your position on the field -> to determine field width and height
+    void Asteroids2DShip::showposition()
+    {
+        Vector3 pos = this->getPosition();
+        orxout() << "x = "<< pos.x << " y = " << pos.y << " z = "<< pos.z << endl; 
     }
 
@@ -56,4 +66,19 @@
     {
         SUPER(Asteroids2DShip, tick, dt);
+        Vector3 pos = this->getPosition();
+
+        //haelt ship innerhalb des Kamerafensters, kommt oben bzw seitlich wieder raus. Man spawnt in (0,0)
+        if(pos.x > width/2)   pos.x = -width/2;
+        if(pos.x < -width/2)  pos.x = width/2;
+        if(pos.z > height/2)  pos.z = -height/2;
+        if(pos.z < -height/2) pos.z = height/2;
+
+        //2D movement, position should always = 0 on y-axis
+        if(pos.y!=0) pos.y = 0;
+        this->setPosition(pos);
+
+        //update level
+
+        //shoot?
     }
 
Index: code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DShip.h
===================================================================
--- code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DShip.h	(revision 11608)
+++ code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DShip.h	(revision 11613)
@@ -45,4 +45,7 @@
 //#include "Asteroids2DCenterPoint.h"
 
+#include "tools/Timer.h"
+
+
 namespace orxonox
 {
@@ -61,10 +64,10 @@
             virtual void boost(bool bBoost) override;
 
-            //no rotation!
-            virtual void rotateYaw(const Vector2& value) override{};
-            virtual void rotatePitch(const Vector2& value) override{};
+            //no rotation in x and z direction!
+            virtual void rotateYaw(const Vector2& value) override{}; // Rotate in yaw direction.
+            virtual void rotatePitch(const Vector2& value) override{}; // Rotate in pitch direction.
+            virtual void rotateRoll(const Vector2& value) override{}; // Rotate in roll direction.
 
-            //return to main menu if game has ended.
-            virtual void rotateRoll(const Vector2& value) override{if (getGame()) if (getGame()->bEndGame) getGame()->end();};
+
 
             virtual void updateLevel();
@@ -74,4 +77,5 @@
             float speed, damping, posforeward;
             bool isFireing;
+            void showposition();
 
         protected:
@@ -80,4 +84,5 @@
         private:
             Asteroids2D* getGame();
+            float width, height;
             WeakPtr<Asteroids2D> game;
             WeakPtr<WorldEntity> lastEntity;
@@ -89,4 +94,5 @@
             } velocity, desiredVelocity;
 
+            Timer timer;
     };
 }