Index: /code/branches/Asteroid_HS17/data/levels/Asteroids2D.oxw
===================================================================
--- /code/branches/Asteroid_HS17/data/levels/Asteroids2D.oxw	(revision 11613)
+++ /code/branches/Asteroid_HS17/data/levels/Asteroids2D.oxw	(revision 11614)
@@ -45,5 +45,35 @@
     <SpawnPoint team=0 position="0,0,0" lookat="0,0,0" spawnclass= Asteroids2DShip pawndesign=spaceshipasteroids2d />
 
-    <Model mesh="axes.mesh" scale=10 position="0,0,0" />
+    <!--<Model mesh="axes.mesh" scale=10 position="0,0,0" /> -->
+
+
+    <?lua
+      for i = 1, 250, 1
+      do
+      j = math.random()
+    ?>
+
+    <MovableEntity
+      position = "<?lua print(math.random()* 15000 - 1000) ?>,<?lua print(math.random() * 12000 - 4000) ?>,<?lua print(math.random() * 12000 - 4000) ?>"
+      collisionType = dynamic
+      linearDamping = 0.8
+      angularDamping = 0
+      scale = "<?lua print(j * 150)?>"
+      collisiondamage = 1
+      enablecollisiondamage = true
+    >
+      <attached>
+        <Model mass="<?lua print(j * 1000) ?>" mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" />
+      </attached>
+      <collisionShapes>
+        <SphereCollisionShape radius="<?lua print(j * 350) ?>" />
+      </collisionShapes>
+    </MovableEntity>
+
+    <?lua
+      end
+    ?>
+
+
     <Asteroids2DCenterPoint name=asteroids2Dcenter />
   
Index: /code/branches/Asteroid_HS17/data/levels/templates/spaceshipAsteroids2D.oxt
===================================================================
--- /code/branches/Asteroid_HS17/data/levels/templates/spaceshipAsteroids2D.oxt	(revision 11613)
+++ /code/branches/Asteroid_HS17/data/levels/templates/spaceshipAsteroids2D.oxt	(revision 11614)
@@ -20,5 +20,5 @@
    primaryThrust     = 150
    auxilaryThrust    = 30
-   rotationThrust    = 500
+   rotationThrust    = 100
 
    lift = 1;
@@ -85,5 +85,5 @@
     <CameraPosition position="0,1300,-100" direction="0, -1, 0" drag=false mouselook=true />
 -->
-    <CameraPosition position="0,600,0" pitch=-90 absolute=true />
+    <CameraPosition position="0,600,0" pitch=-90 absolute=true drag = false mouselook=true/>
     <CameraPosition position="0,50,160" drag=true mouselook=true />
     <CameraPosition position="0,40,125" drag=true mouselook=true />
Index: /code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DCube.cc
===================================================================
--- /code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DCube.cc	(revision 11613)
+++ /code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DCube.cc	(revision 11614)
@@ -34,4 +34,5 @@
 #include "Asteroids2D.h"
 #include "core/CoreIncludes.h"
+#include "util/Math.h"
 
 namespace orxonox
@@ -39,7 +40,19 @@
     RegisterClass(Asteroids2DCube);
 
-    Asteroids2DCube::Asteroids2DCube(Context* context) : MovableEntity(context)
+    Asteroids2DCube::Asteroids2DCube(Context* context) : Pawn(context)
     {
         RegisterObject(Asteroids2DCube);
+        this->size = 1;
+        this->width = 1043;
+        this->height = 646;
+        //this->setPosition();
+        //this->setVelocity(Vector3 )
+    }
+
+    void Asteroids2DCube::tick(float dt)
+    {
+    	SUPER(Asteroids2DCube, tick, dt);
+    	
+
     }
 
Index: /code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DCube.h
===================================================================
--- /code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DCube.h	(revision 11613)
+++ /code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DCube.h	(revision 11614)
@@ -38,15 +38,18 @@
 #include "asteroids2D/Asteroids2DPrereqs.h"
 
-#include "worldentities/MovableEntity.h"
+#include "worldentities/pawns/Pawn.h"
 
 
 namespace orxonox
 {
-    class _Asteroids2DExport Asteroids2DCube : public MovableEntity
+    class _Asteroids2DExport Asteroids2DCube : public Pawn
     {
        public:
             Asteroids2DCube(Context* context);
+            virtual void tick(float dt) override;
 
        private:
+       		int size;				// three sizes, 3-> two 2s, 2-> two 1s, 1-> die
+       		float width, height;	//field
     };
 }
Index: /code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DShip.h
===================================================================
--- /code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DShip.h	(revision 11613)
+++ /code/branches/Asteroid_HS17/src/modules/asteroids2D/Asteroids2DShip.h	(revision 11614)
@@ -65,5 +65,5 @@
 
             //no rotation in x and z direction!
-            virtual void rotateYaw(const Vector2& value) override{}; // Rotate in yaw direction.
+            //virtual void rotateYaw(const Vector2& value) override{}; // Rotate in yaw direction.
             virtual void rotatePitch(const Vector2& value) override{}; // Rotate in pitch direction.
             virtual void rotateRoll(const Vector2& value) override{}; // Rotate in roll direction.